/*
 * <aisl/instance.h>
 *
 * Copyright (c) 2017-2019 by Löwenware Ltd.
 *
 * Project homepage: https://lowenware.com/aisl/
 *
 */

#ifndef INSTANCE_H_60576F41_454C_4189_B91A_F40501132230
#define INSTANCE_H_60576F41_454C_4189_B91A_F40501132230

#include <stdint.h>
#include <stdarg.h>


typedef struct aisl_instance * aisl_instance_t;


/* Initialization functions */

aisl_instance_t
aisl_new( aisl_config_t * config );


void
aisl_free( aisl_instance_t instance );


aisl_server_t
aisl_listen( aisl_instance_t    instance,
             const char       * address,
             uint16_t           port );


#ifdef AISL_WITH_SSL

aisl_status_t
aisl_set_ssl( aisl_instance_t  instance,
              const char     * hostname,
              const char     * key_file,
              const char     * crt_file );

#endif


aisl_status_t
aisl_set_callback( aisl_instance_t    instance,
                   void             * source,
                   aisl_event_t       e_id,
                   aisl_callback_t    cb );


/* Control functions */

aisl_status_t
aisl_run_cycle( aisl_instance_t instance );


const char *
aisl_get_error( aisl_instance_t instance );


aisl_status_t
aisl_sleep( aisl_instance_t instance, uint32_t usec );


aisl_status_t
aisl_raise( aisl_instance_t instance, aisl_event_t event, ...);


aisl_status_t
aisl_raisev( aisl_instance_t instance, aisl_event_t event, va_list args);

#endif /* !INSTANCE_H */
